searchNodes=[{"doc":"Nerves.Runtime contains functions useful for almost all Nerves-based devices.","ref":"Nerves.Runtime.html","title":"Nerves.Runtime","type":"module"},{"doc":"Run system command and log output into logger. NOTE: Unlike System.cmd/3, this does not raise if the executable isn't found","ref":"Nerves.Runtime.html#cmd/3","title":"Nerves.Runtime.cmd/3","type":"function"},{"doc":"Return whether the firmware has been marked as valid See validate_firmware/0 for more information.","ref":"Nerves.Runtime.html#firmware_valid?/0","title":"Nerves.Runtime.firmware_valid?/0","type":"function"},{"doc":"Halt the device (meaning hang, not power off, nor reboot). Note: this is different than :erlang.halt(), which exits BEAM, and may end up rebooting the device if erlinit.config settings allow reboot on exit.","ref":"Nerves.Runtime.html#halt/0","title":"Nerves.Runtime.halt/0","type":"function"},{"doc":"Power off the device. This calls :init.stop/0 internally. If :init.stop/0 takes longer than the erlinit.config 's --graceful-powerdown setting (likely 10 seconds) then the system will be hard rebooted.","ref":"Nerves.Runtime.html#poweroff/0","title":"Nerves.Runtime.poweroff/0","type":"function"},{"doc":"Reboot the device and gracefully shutdown the Erlang VM. This calls :init.stop/0 internally. If :init.stop/0 takes longer than the erlinit.config 's --graceful-powerdown setting (likely 10 seconds) then the system will be hard rebooted.","ref":"Nerves.Runtime.html#reboot/0","title":"Nerves.Runtime.reboot/0","type":"function"},{"doc":"Revert the device to running the previous firmware. This requires a specially constructed fw file.","ref":"Nerves.Runtime.html#revert/1","title":"Nerves.Runtime.revert/1","type":"function"},{"doc":"Return the device's serial number Serial number storage is device-specific and configurable. Serial numbers can be programmed in one-time programmable locations like in CPU ROM or cryptographic elements. They can also be in rewritable locations like a U-Boot environment block. Nerves uses the boardid by default (set :boardid_path key in the application environment to another program to override). Boardid uses the /etc/boardid.config file to determine how to read the serial number. Official Nerves systems provide reasonable default mechanisms for getting started. Override this file in your application's rootfs_overlay to customize it. This function never raises. If a serial number isn't available for any reason, it will return a serial number of &quot;unconfigured&quot; .","ref":"Nerves.Runtime.html#serial_number/0","title":"Nerves.Runtime.serial_number/0","type":"function"},{"doc":"Return whether the application was built for either the host or the target","ref":"Nerves.Runtime.html#target/0","title":"Nerves.Runtime.target/0","type":"function"},{"doc":"Mark the running firmware as valid A device cannot receive a new firmware if the current one has not been validated. In the official Nerves systems, this typically happens automatically. If you are handling the firmware validation in your app, then this function can be used as a helper to mark firmware as valid. For systems that support automatic reverting, if the firmware is not marked as valid, then the next reboot will cause a revert to the old firmware","ref":"Nerves.Runtime.html#validate_firmware/0","title":"Nerves.Runtime.validate_firmware/0","type":"function"},{"doc":"Options for Nerves.Runtime.revert/1 . :reboot - Call Nerves.Runtime.reboot/0 after reverting (defaults to true )","ref":"Nerves.Runtime.html#t:revert_options/0","title":"Nerves.Runtime.revert_options/0","type":"type"},{"doc":"GenServer that handles device initialization. Initialization currently consists of: Mounting the application partition If the application partition can't be mounted, format it, and then mount it. Device initialization is usually a first boot only operation. It's possible that device filesystems get corrupt enough to cause them to be reinitialized. Since corruption should be rare, Nerves systems create firmware images without formatting the application partition. This has the benefit of exercising the corruption repair code. It's also required since some filesystem types can only be formatted on device. Long format times can be problematic in manufacturing. If this is an issue, see if you can use F2FS since it formats much faster than ext4. Some devices have also had stalls when formatting while waiting for enough entropy to generate a UUID. Look into hardcoding UUIDs or enabling a hw random number generator to increase entropy.","ref":"Nerves.Runtime.Init.html","title":"Nerves.Runtime.Init","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Nerves.Runtime.Init.html#child_spec/1","title":"Nerves.Runtime.Init.child_spec/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.Init.html#init_application_partition/0","title":"Nerves.Runtime.Init.init_application_partition/0","type":"function"},{"doc":"","ref":"Nerves.Runtime.Init.html#start_link/1","title":"Nerves.Runtime.Init.start_link/1","type":"function"},{"doc":"Key Value storage for firmware variables provided by fwup. KV provides functionality to read and modify firmware metadata set by fwup. The firmware metadata contains information such as the active firmware slot, where the application data partition is located, etc. The firmware metadata store is a simple key-value store where both keys and values are stored as strings. The firmware metadata is stored in the U-boot environment block stored at the beginning of the disk outside of actual partitions. It is not stored redundantly, and it can be susceptible to corruption in case of power failure during writes. For this reason, it is recommended to use the firmware metadata with caution. The access patterns in this module lower the risk of corruption, and risk can be lowered further by storing as little data as possible in the firmware metadata. UBootEnv can alternatively be used for more direct access to the firmware metadata. However, since KV utilizes caching of the firmware metadata, you should use either KV or UBootEnv, not both. Examples Getting all firmware metadata: iex&gt; Nerves.Runtime.KV . get_all ( ) %{ &quot;a.nerves_fw_application_part0_devpath&quot; =&gt; &quot;/dev/mmcblk0p3&quot; , &quot;a.nerves_fw_application_part0_fstype&quot; =&gt; &quot;ext4&quot; , &quot;a.nerves_fw_application_part0_target&quot; =&gt; &quot;/root&quot; , &quot;a.nerves_fw_architecture&quot; =&gt; &quot;arm&quot; , &quot;a.nerves_fw_author&quot; =&gt; &quot;The Nerves Team&quot; , &quot;a.nerves_fw_description&quot; =&gt; &quot;&quot; , &quot;a.nerves_fw_misc&quot; =&gt; &quot;&quot; , &quot;a.nerves_fw_platform&quot; =&gt; &quot;rpi0&quot; , &quot;a.nerves_fw_product&quot; =&gt; &quot;test_app&quot; , &quot;a.nerves_fw_uuid&quot; =&gt; &quot;d9492bdb-94de-5288-425e-2de6928ef99c&quot; , &quot;a.nerves_fw_vcs_identifier&quot; =&gt; &quot;&quot; , &quot;a.nerves_fw_version&quot; =&gt; &quot;0.1.0&quot; , &quot;b.nerves_fw_application_part0_devpath&quot; =&gt; &quot;/dev/mmcblk0p3&quot; , &quot;b.nerves_fw_application_part0_fstype&quot; =&gt; &quot;ext4&quot; , &quot;b.nerves_fw_application_part0_target&quot; =&gt; &quot;/root&quot; , &quot;b.nerves_fw_architecture&quot; =&gt; &quot;arm&quot; , &quot;b.nerves_fw_author&quot; =&gt; &quot;The Nerves Team&quot; , &quot;b.nerves_fw_description&quot; =&gt; &quot;&quot; , &quot;b.nerves_fw_misc&quot; =&gt; &quot;&quot; , &quot;b.nerves_fw_platform&quot; =&gt; &quot;rpi0&quot; , &quot;b.nerves_fw_product&quot; =&gt; &quot;test_app&quot; , &quot;b.nerves_fw_uuid&quot; =&gt; &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot; , &quot;b.nerves_fw_vcs_identifier&quot; =&gt; &quot;&quot; , &quot;b.nerves_fw_version&quot; =&gt; &quot;0.1.1&quot; , &quot;nerves_fw_active&quot; =&gt; &quot;b&quot; , &quot;nerves_fw_devpath&quot; =&gt; &quot;/dev/mmcblk0&quot; , &quot;nerves_serial_number&quot; =&gt; &quot;&quot; } Parts of the firmware metadata are global, while others pertain to a specific firmware slot. This is indicated by the key - data which describes firmware of a specific slot have keys prefixed with the name of the firmware slot. In the above example, &quot;nerves_fw_active&quot; and &quot;nerves_serial_number&quot; are global, while &quot;a.nerves_fw_version&quot; and &quot;b.nerves_fw_version&quot; apply to the &quot;a&quot; and &quot;b&quot; firmware slots, respectively. It is also possible to get firmware metadata that only pertains to the currently active firmware slot: iex&gt; Nerves.Runtime.KV . get_all_active ( ) %{ &quot;nerves_fw_application_part0_devpath&quot; =&gt; &quot;/dev/mmcblk0p3&quot; , &quot;nerves_fw_application_part0_fstype&quot; =&gt; &quot;ext4&quot; , &quot;nerves_fw_application_part0_target&quot; =&gt; &quot;/root&quot; , &quot;nerves_fw_architecture&quot; =&gt; &quot;arm&quot; , &quot;nerves_fw_author&quot; =&gt; &quot;The Nerves Team&quot; , &quot;nerves_fw_description&quot; =&gt; &quot;&quot; , &quot;nerves_fw_misc&quot; =&gt; &quot;&quot; , &quot;nerves_fw_platform&quot; =&gt; &quot;rpi0&quot; , &quot;nerves_fw_product&quot; =&gt; &quot;test_app&quot; , &quot;nerves_fw_uuid&quot; =&gt; &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot; , &quot;nerves_fw_vcs_identifier&quot; =&gt; &quot;&quot; , &quot;nerves_fw_version&quot; =&gt; &quot;0.1.1&quot; } Note that get_all_active/0 strips out the a. and b. prefixes. Further, the two functions get/1 and get_active/1 allow you to get a specific key from the firmware metadata. get/1 requires specifying the entire key name, while get_active/1 will prepend the slot prefix for you: iex&gt; Nerves.Runtime.KV . get ( &quot;nerves_fw_active&quot; ) &quot;b&quot; iex&gt; Nerves.Runtime.KV . get ( &quot;b.nerves_fw_uuid&quot; ) &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot; iex&gt; Nerves.Runtime.KV . get_active ( &quot;nerves_fw_uuid&quot; ) &quot;4e08ad59-fa3c-5498-4a58-179b43cc1a25&quot; Aside from reading values from the KV store, it is also possible to write new values to the firmware metadata. New values may either have unique keys, in which case they will be added to the firmware metadata, or re-use a key, in which case they will overwrite the current value with that key: iex&gt; :ok = Nerves.Runtime.KV . put ( &quot;my_firmware_key&quot; , &quot;my_value&quot; ) iex&gt; :ok = Nerves.Runtime.KV . put ( &quot;nerves_serial_number&quot; , &quot;my_new_serial_number&quot; ) iex&gt; Nerves.Runtime.KV . get ( &quot;my_firmware_key&quot; ) &quot;my_value&quot; iex&gt; Nerves.Runtime.KV . get ( &quot;nerves_serial_number&quot; ) &quot;my_new_serial_number&quot; It is possible to write a collection of values at once, in order to minimize number of writes: iex&gt; :ok = Nerves.Runtime.KV . put ( %{ &quot;one_key&quot; =&gt; &quot;one_val&quot; , &quot;two_key&quot; =&gt; &quot;two_val&quot; } ) iex&gt; Nerves.Runtime.KV . get ( &quot;one_key&quot; ) &quot;one_val&quot; Lastly, put_active/1 and put_active/2 allow you to write firmware metadata to the currently active firmware slot without specifying the slot prefix yourself: iex&gt; :ok = Nerves.Runtime.KV . put_active ( &quot;nerves_fw_misc&quot; , &quot;Nerves is awesome&quot; ) iex&gt; Nerves.Runtime.KV . get_active ( &quot;nerves_fw_misc&quot; ) &quot;Nerves is awesome&quot;","ref":"Nerves.Runtime.KV.html","title":"Nerves.Runtime.KV","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Nerves.Runtime.KV.html#child_spec/1","title":"Nerves.Runtime.KV.child_spec/1","type":"function"},{"doc":"Get the key regardless of firmware slot","ref":"Nerves.Runtime.KV.html#get/1","title":"Nerves.Runtime.KV.get/1","type":"function"},{"doc":"Get the key for only the active firmware slot","ref":"Nerves.Runtime.KV.html#get_active/1","title":"Nerves.Runtime.KV.get_active/1","type":"function"},{"doc":"Get all keys regardless of firmware slot","ref":"Nerves.Runtime.KV.html#get_all/0","title":"Nerves.Runtime.KV.get_all/0","type":"function"},{"doc":"Get all key value pairs for only the active firmware slot","ref":"Nerves.Runtime.KV.html#get_all_active/0","title":"Nerves.Runtime.KV.get_all_active/0","type":"function"},{"doc":"Initialize the KV store and return its contents This will be called on boot and should return all persisted key/value pairs. The results will be cached and if a change should be persisted, put/1 will be called with the update. The opts parameter is currently unused, but may supply configuration options in the future.","ref":"Nerves.Runtime.KV.html#c:init/1","title":"Nerves.Runtime.KV.init/1","type":"callback"},{"doc":"Write a collection of key-value pairs to the firmware metadata","ref":"Nerves.Runtime.KV.html#put/1","title":"Nerves.Runtime.KV.put/1","type":"function"},{"doc":"Persist the updated KV pairs The KV map contains the KV pairs returned by init/1 with any changes made by users of Nerves.Runtime.KV .","ref":"Nerves.Runtime.KV.html#c:put/1","title":"Nerves.Runtime.KV.put/1","type":"callback"},{"doc":"Write a key-value pair to the firmware metadata","ref":"Nerves.Runtime.KV.html#put/2","title":"Nerves.Runtime.KV.put/2","type":"function"},{"doc":"Write a collection of key-value pairs to the active firmware slot","ref":"Nerves.Runtime.KV.html#put_active/1","title":"Nerves.Runtime.KV.put_active/1","type":"function"},{"doc":"Write a key-value pair to the active firmware slot","ref":"Nerves.Runtime.KV.html#put_active/2","title":"Nerves.Runtime.KV.put_active/2","type":"function"},{"doc":"Start the KV store server","ref":"Nerves.Runtime.KV.html#start_link/1","title":"Nerves.Runtime.KV.start_link/1","type":"function"},{"doc":"The KV store is a string -&gt; string map Since the KV store is backed by things like the U-Boot environment blocks, the keys and values can't be just any string. For example, characters with the value 0 (i.e., NULL ) are disallowed. The = sign is also disallowed in keys. Values may have embedded new lines. In general, it's recommended to stick with ASCII values to avoid causing trouble when working with C programs and U-Boot which also access the variables.","ref":"Nerves.Runtime.KV.html#t:string_map/0","title":"Nerves.Runtime.KV.string_map/0","type":"type"},{"doc":"Applications that depend on nerves_runtime for accessing provisioning information from the Nerves.Runtime.KV can mock the contents through the Application config. config :nerves_runtime , Nerves.Runtime.KV.Mock , %{ &quot;key&quot; =&gt; &quot;value&quot; }","ref":"Nerves.Runtime.KV.Mock.html","title":"Nerves.Runtime.KV.Mock","type":"module"},{"doc":"GenServer that captures Linux uevent messages and passes them up to Elixir.","ref":"Nerves.Runtime.Kernel.UEvent.html","title":"Nerves.Runtime.Kernel.UEvent","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Nerves.Runtime.Kernel.UEvent.html#child_spec/1","title":"Nerves.Runtime.Kernel.UEvent.child_spec/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.Kernel.UEvent.html#registry/4","title":"Nerves.Runtime.Kernel.UEvent.registry/4","type":"function"},{"doc":"","ref":"Nerves.Runtime.Kernel.UEvent.html#start_link/1","title":"Nerves.Runtime.Kernel.UEvent.start_link/1","type":"function"},{"doc":"Functions for parsing kmsg strings","ref":"Nerves.Runtime.Log.KmsgParser.html","title":"Nerves.Runtime.Log.KmsgParser","type":"module"},{"doc":"Parse out the kmsg facility, severity, and message (including the timestamp and host) from a kmsg-formatted string. See https://elixir.bootlin.com/linux/latest/source/Documentation/ABI/testing/dev-kmsg for full details. Most messages are of the form: priority,sequence,timestamp,flag;message priority is an integer that when broken apart gives you a facility and severity. sequence is a monotonically increasing counter timestamp is the time in microseconds flag is almost always - message is everything else This parser only supports the minimum kmsg reports. The spec above describes more functionality, but it appears to be uncommon and I haven't seen any examples yet in my testing.","ref":"Nerves.Runtime.Log.KmsgParser.html#parse/1","title":"Nerves.Runtime.Log.KmsgParser.parse/1","type":"function"},{"doc":"Collects operating system-level messages from /proc/kmsg , forwarding them to Logger with an appropriate level to match the syslog priority parsed out of the message.","ref":"Nerves.Runtime.Log.KmsgTailer.html","title":"Nerves.Runtime.Log.KmsgTailer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Nerves.Runtime.Log.KmsgTailer.html#child_spec/1","title":"Nerves.Runtime.Log.KmsgTailer.child_spec/1","type":"function"},{"doc":"Start the kmsg monitoring GenServer.","ref":"Nerves.Runtime.Log.KmsgTailer.html#start_link/1","title":"Nerves.Runtime.Log.KmsgTailer.start_link/1","type":"function"},{"doc":"Functions for parsing syslog strings","ref":"Nerves.Runtime.Log.SyslogParser.html","title":"Nerves.Runtime.Log.SyslogParser","type":"module"},{"doc":"Decode a syslog priority to facility and severity","ref":"Nerves.Runtime.Log.SyslogParser.html#decode_priority/1","title":"Nerves.Runtime.Log.SyslogParser.decode_priority/1","type":"function"},{"doc":"Parse out the syslog facility, severity, and message (including the timestamp and host) from a syslog-formatted string. The message is of the form: &lt;pri&gt;message pri is an integer that when broken apart gives you a facility and severity. message is everything else.","ref":"Nerves.Runtime.Log.SyslogParser.html#parse/1","title":"Nerves.Runtime.Log.SyslogParser.parse/1","type":"function"},{"doc":"Convert severity to an Elixir logger level","ref":"Nerves.Runtime.Log.SyslogParser.html#severity_to_logger/1","title":"Nerves.Runtime.Log.SyslogParser.severity_to_logger/1","type":"function"},{"doc":"","ref":"Nerves.Runtime.Log.SyslogParser.html#t:facility/0","title":"Nerves.Runtime.Log.SyslogParser.facility/0","type":"type"},{"doc":"","ref":"Nerves.Runtime.Log.SyslogParser.html#t:severity/0","title":"Nerves.Runtime.Log.SyslogParser.severity/0","type":"type"},{"doc":"This GenServer routes syslog messages from C-based applications and libraries through the Elixir Logger for collection.","ref":"Nerves.Runtime.Log.SyslogTailer.html","title":"Nerves.Runtime.Log.SyslogTailer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Nerves.Runtime.Log.SyslogTailer.html#child_spec/1","title":"Nerves.Runtime.Log.SyslogTailer.child_spec/1","type":"function"},{"doc":"Start the local syslog GenServer.","ref":"Nerves.Runtime.Log.SyslogTailer.html#start_link/1","title":"Nerves.Runtime.Log.SyslogTailer.start_link/1","type":"function"},{"doc":"nerves_runtime nerves_runtime is a core component of Nerves. It contains applications and libraries that are expected to be useful on all Nerves devices. Here are its features: Generic system and filesystem initialization (suitable for use with shoehorn ) Introspection of Nerves system, firmware, and deployment metadata Device reboot and shutdown A small Linux kernel uevent application for capturing hardware change events and more Device serial numbers The following sections describe the features in more detail. For more information, see the hex docs .","ref":"readme.html","title":"nerves_runtime","type":"extras"},{"doc":"nerves_runtime provides an OTP application ( nerves_runtime ) that can initialize the system when it is started. For this to be useful, nerves_runtime must be started before other OTP applications, since most will assume that the system is already initialized before they start. To set up nerves_runtime to work with shoehorn , you will need to do the following: Include shoehorn in mix.exs Include shoehorn in your rel/config.exs Ensure that :nerves_runtime is at the beginning of the init: list in your config/config.exs : config :shoehorn , overlay_path : &quot;&quot; , init : [ :nerves_runtime , :other_app1 , :other_app2 ] , app : :your_app Kernel Modules nerves_runtime will attempt to auto-load kernel modules by calling modprobe using the modalias supplied by the device's uevent message. You can disable this feature by configuring autoload: false in your application configuration: config :nerves_runtime , :kernel , autoload_modules : false nerves_runtime can optionally report device insertions and removals through SystemRegistry . This is currently the default, but you can disable it via configuration: config :nerves_runtime , :kernel , use_system_registry : false","ref":"readme.html#system-initialization","title":"nerves_runtime - System Initialization","type":"extras"},{"doc":"Nerves systems generally ship with one or more application filesystem partitions. These are used for persisting data that is expected to live between firmware updates. The root filesystem cannot be used since it is mounted as read-only by default. nerves_runtime takes an unforgiving approach to managing the application partition: if it can't be mounted as read-write, it gets re-formatted. While filesystem corruption should be a rare event, even with unexpected loss of power, Nerves devices may not always be accessible for manual recovery. This default behavior provides a basic recoverability guarantee. To verify that this recovery works, Nerves systems usually leave the application filesystems uninitialized so that the format operation happens on the first boot. This means that the first boot takes slightly longer than subsequent boots. Note that a common implementation of &quot;reset to factory defaults&quot; is to purposely corrupt the application partition and reboot. nerves_runtime uses firmware metadata to determine how to mount and initialize the application partition. The following variables are important: [partition].nerves_fw_application_part0_devpath - the path to the application partition (e.g. /dev/mmcblk0p3 ) [partition].nerves_fw_application_part0_fstype - the type of filesystem (e.g. ext4 ) [partition].nerves_fw_application_part0_target - where the partition should be mounted (e.g. /root or /mnt/appdata )","ref":"readme.html#filesystem-initialization","title":"nerves_runtime - Filesystem Initialization","type":"extras"},{"doc":"All official Nerves systems maintain a list of key-value pairs for tracking various information about the system. This information is not intended to be written frequently. To get this information, you can call one of the following: Nerves.Runtime.KV.get_all_active/0 - return all key-value pairs associated with the active firmware. Nerves.Runtime.KV.get_all/0 - return all key-value pairs, including those from the inactive firmware, if any. Nerves.Runtime.KV.get_active/1 - look up the value of a key associated with the active firmware. Nerves.Runtime.KV.get/1 - look up the value of a key, including those from the inactive firmware, if any. Global Nerves metadata includes the following: Key Build Environment Variable Example Value Description nerves_fw_active N/A &quot;a&quot; This key holds the prefix that identifies the active firmware metadata. In this example, all keys starting with &quot;a.&quot; hold information about the running firmware. nerves_fw_devpath NERVES_FW_DEVPATH &quot;/dev/mmcblk0&quot; This is the primary storage device for the firmware. nerves_serial_number N/A &quot;12345abc&quot; This is a text serial number. See Serial numbers for details. nerves_fw_validated N/A 0 Set to &quot;1&quot; to indicate that the currently running firmware is valid. (Only supported on some platforms) nerves_fw_autovalidate N/A 1 Set to &quot;1&quot; to indicate that firmware updates are valid without any additional checks. (Only supported on some platforms) upgrade_available N/A 0 If using the U-Boot bootloader AND U-Boot's bootcount feature, then the upgrade_available variable is used instead of nerves_fw_validated (it has the opposite meaning) bootcount N/A 1 If using the U-Boot bootloader AND U-Boot's bootcount feature, then this is the number of times an unvalidated firmware has been booted. bootlimit N/A 1 If using the U-Boot bootloader AND U-Boot's bootcount feature, then this is the max number of tries for unvalidated firmware. Firmware-specific Nerves metadata includes the following: Key Example Value Description nerves_fw_application_part0_devpath &quot;/dev/mmcblk0p3&quot; The block device that contains the application partition nerves_fw_application_part0_fstype &quot;ext4&quot; The application partition's filesystem type nerves_fw_application_part0_target &quot;/root&quot; Where to mount the application partition nerves_fw_architecture &quot;arm&quot; The processor architecture (Not currently used) nerves_fw_author &quot;John Doe&quot; The person or company that created this firmware nerves_fw_description &quot;Stuff&quot; A description of the project nerves_fw_platform &quot;rpi3&quot; A name to identify the board that this runs on. It can be checked in the fwup.conf before performing an upgrade. nerves_fw_product &quot;My Product&quot; A product name that may show up in a firmware selection list, for example nerves_fw_version &quot;1.0.0&quot; The project's version nerves_fw_vcs_identifier &quot;bdeead38...&quot; A git SHA or other identifier (optional) nerves_fw_misc &quot;anything...&quot; Any application info that doesn't fit in another field (optional) Note that the keys are stored in the environment block prefixed by the firmware slot for which they pertain. For example, a.nerves_fw_description is the description for the firmware in the &quot;A&quot; slot. Several of the keys can be set in the mix.exs file of your main Nerves project. This is the preferred way to set them because it requires the least amount of effort. Assuming that your fwup.conf respects the fwup variable names listed in the table, the keys can also be overridden by setting environment variables at build time. Depending on your project, you may prefer to set them using a customized fwup.conf configuration file instead. The fwup -m value shows the key that you'll see if you run fwup -m -i project.fw to extract the firmware metadata from the .fw file. Key in Nerves.Runtime Key in mix.exs Build Environment Variable Key in fwup -m nerves_fw_application_part0_devpath N/A NERVES_FW_APPLICATION_PART0_DEVPATH N/A nerves_fw_application_part0_fstype N/A NERVES_FW_APPLICATION_PART0_FSTYPE N/A nerves_fw_application_part0_target N/A NERVES_FW_APPLICATION_PART0_TARGET N/A nerves_fw_architecture N/A NERVES_FW_ARCHITECTURE meta-architecture nerves_fw_author :author NERVES_FW_AUTHOR meta-author nerves_fw_description :description NERVES_FW_DESCRIPTION meta-description nerves_fw_platform N/A NERVES_FW_PLATFORM meta-platform nerves_fw_product :name NERVES_FW_PRODUCT meta-product nerves_fw_version :version NERVES_FW_VERSION meta-version nerves_fw_vcs_identifier N/A NERVES_FW_VCS_IDENTIFIER meta-vcs-identifier nerves_fw_misc N/A NERVES_FW_MISC meta-misc","ref":"readme.html#nerves-system-and-firmware-metadata","title":"nerves_runtime - Nerves System and Firmware Metadata","type":"extras"},{"doc":"Rebooting, powering-off, and halting a device work by signaling to erlinit an intention to shutdown and then exiting the Erlang VM by calling :init.stop/0 . The Nerves.Runtime.reboot/0 and related utilities are helper methods for this. Once they return, the Erlang VM will likely only be available momentarily before shutdown. If the OTP applications cannot be stopped within a timeout as specified in the erlinit.config , erlinit will ungracefully terminate the Erlang VM.","ref":"readme.html#device-reboot-and-shutdown","title":"nerves_runtime - Device Reboot and Shutdown","type":"extras"},{"doc":"If you'd like to go back to the previous version of firmware running on a device, you can do that if the Nerves system supports it. At the IEx prompt, run: iex&gt; Nerves.Runtime . revert Running this command manually is useful in development. Production use requires more work to protect against faulty upgrades. Assisted firmware validation and automatic revert Nerves firmware updates protect against update corruption and power loss midway into the update procedure. However, what happens if the firmware update contains bad code that hangs the device or breaks something important like networking? Some Nerves systems support tentative runs of new firmware and if something goes wrong, they'll revert back. At a high level, this involves some additional code from the developer that knows what constitutes &quot;working&quot;. This could be &quot;is it possible to connect to the firmware update server within 5 minutes of boot?&quot; Here's the process: New firmware is installed in the normal manner. The Nerves.Runtime.KV variable, nerves_fw_validated is set to 0. (The systems fwup.conf does this) The system reboots like normal. The device starts a five minute reboot timer (your code needs to do this if you want to catch hangs or super-slow boots) The application attempts to make a connection to the firmware update server. On a good connection, the application sets nerves_fw_validated to 1 by calling Nerves.Runtime.validate_firmware/0 and cancels the reboot timer. On error, the reboot timer failing, or a hardware watchdog timeout, the system reboots. The bootloader reverts to the previous firmware. Some Nerves systems support a KV variable called nerves_fw_autovalidate . The intention of this variable was to make that system support scenarios that require validate and ones that don't. If the system supports this variable then you should make sure that it is set to 0 (either via a custom fwup.conf or via the provisioning hooks for writing serial numbers to MicroSD cards). Support for the nerves_fw_autovalidate variable will likely go away in the future as steps are made to make automatic revert on bad firmware a default feature of Nerves rather than an add-on. U-Boot assisted automatic revert U-Boot provides a bootcount feature that can be used to try out new firmware and revert it if it fails. At a high level, it works similar to logic just described except that it can attempt a new firmware more than once if desired. This can help if validating a firmware image depends on factors out of your control and you want a few tries to happen before giving up. To use this, you need to enable the following U-Boot configuration items: CONFIG_BOOTCOUNT_LIMIT = y CONFIG_BOOTCOUNT_ENV = y See the U-Boot documentation for more information. The gist is to have your bootcmd handle normal booting and then add an altbootcmd to revert the firmware. The firmware update should set the upgrade_available U-Boot environment variable to &quot;1&quot; to indicate that boot counting should start. Nerves.Runtime.validate_firmware/0 knows about upgrade_available , so when you call it to indicate that the firmware is ok, it will set upgrade_available back to &quot;0&quot; and reset &quot;bootcount&quot; . Best effort automatic revert Unfortunately, the bootloader for platforms like the Raspberry Pi makes it difficult to implement the above mechanism. The following strategy cannot protect against kernel and early boot issues, but it can still provide value: Upgrade firmware the normal way. Record that the next boot will be the first one in the application data partition. On the reboot, if this is the first one, record that the boot happened and revert the firmware with reboot: false . If this is not the first boot, carry on. When you're happy with the new firmware, revert the firmware again with reboot: false . I.e., revert the revert. It is critical that revert is only called once. To make this handle hangs, you'll want to enable a hardware watchdog.","ref":"readme.html#reverting-firmware","title":"nerves_runtime - Reverting firmware","type":"extras"},{"doc":"Operating system-level messages from /dev/log and /proc/kmsg , forwarding them to Logger with an appropriate level to match the syslog priority parsed out of the message.","ref":"readme.html#operating-system-log-collection","title":"nerves_runtime - Operating system log collection","type":"extras"},{"doc":"nerves_runtime receives and processes UEvents from the Linux kernel. The processed events' data is stored in the SystemRegistry . So you need to obtain a current SystemRegistry map before querying the data. E.g.: sr = SystemRegistry . match ( :_ ) Accessing uevent data nerves_runtime stores all device data categorized by subsystem under [:state, &quot;subsystems&quot;] : This map uses the subsystem name as key. It's value is a list of device paths. The list of currently known subsystems can be obtained using: iex&gt; Map . keys ( sr [ :state ] [ &quot;subsystems&quot; ] ) [ &quot;mdio_bus&quot; , &quot;remoteproc&quot; , &quot;regulator&quot; , &quot;iio&quot; , &quot;mem&quot; , &quot;soc&quot; , &quot;queues&quot; , &quot;scsi_host&quot; , &quot;clocksource&quot; , &quot;mmc&quot; , &quot;scsi_device&quot; , &quot;mmc_host&quot; , &quot;i2c&quot; , &quot;bsg&quot; , &quot;dma&quot; , &quot;workqueue&quot; , &quot;misc&quot; , &quot;platform&quot; , &quot;leds&quot; , &quot;spi_master&quot; , &quot;gpio&quot; , &quot;scsi&quot; , &quot;vc&quot; , &quot;usb&quot; , &quot;vtconsole&quot; , &quot;watchdog&quot; , &quot;scsi_disk&quot; , &quot;uio&quot; , &quot;bdi&quot; , &quot;hidg&quot; , &quot;udc&quot; , &quot;mbox&quot; , &quot;cpu&quot; , &quot;nvmem&quot; , &quot;net&quot; , &quot;spi&quot; , &quot;clockevents&quot; , &quot;block&quot; , &quot;mmc_rpmb&quot; , &quot;tty&quot; , &quot;i2c-dev&quot; , &quot;spidev&quot; , &quot;pwm&quot; ] The list of devices paths for a specific subsystem can be obtained as follows: iex&gt; sr [ :state ] [ &quot;subsystems&quot; ] [ &quot;mem&quot; ] [ [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;random&quot; ] , [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;null&quot; ] , [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;urandom&quot; ] , [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;full&quot; ] , [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;kmsg&quot; ] , [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;zero&quot; ] , [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;mem&quot; ] ] WARNING: Compared to the original device paths used by Linux the device path lists contain an additional :state prefix. This allows for a direct usage as keypath into SystemRegistry to access their properties. To access the properties of one of the devices above simply use it's device path with get_in on SystemRegistry : iex&gt; get_in ( sr , [ :state , &quot;devices&quot; , &quot;virtual&quot; , &quot;mem&quot; , &quot;zero&quot; ] ) %{ &quot;devmode&quot; =&gt; &quot;0666&quot; , &quot;devname&quot; =&gt; &quot;zero&quot; , &quot;major&quot; =&gt; &quot;1&quot; , &quot;minor&quot; =&gt; &quot;5&quot; , &quot;subsystem&quot; =&gt; &quot;mem&quot; } WARNING: Please note that the returned map might contain non-binary values for non-leaf devices! iex&gt; get_in ( sr , [ :state , &quot;devices&quot; , &quot;platform&quot; , &quot;ocp&quot; , &quot;481d8000.mmc&quot; , &quot;mmc_host&quot; , &quot;mmc1&quot; , &quot;mmc1:0001&quot; , &quot;block&quot; , &quot;mmcblk1&quot; ] ) %{ &quot;devname&quot; =&gt; &quot;mmcblk1&quot; , &quot;devtype&quot; =&gt; &quot;disk&quot; , &quot;major&quot; =&gt; &quot;179&quot; , &quot;minor&quot; =&gt; &quot;8&quot; , &quot;mmcblk1boot0&quot; =&gt; %{ &quot;devname&quot; =&gt; &quot;mmcblk1boot0&quot; , &quot;devtype&quot; =&gt; &quot;disk&quot; , &quot;major&quot; =&gt; &quot;179&quot; , &quot;minor&quot; =&gt; &quot;16&quot; , &quot;subsystem&quot; =&gt; &quot;block&quot; } , &quot;mmcblk1boot1&quot; =&gt; %{ &quot;devname&quot; =&gt; &quot;mmcblk1boot1&quot; , &quot;devtype&quot; =&gt; &quot;disk&quot; , &quot;major&quot; =&gt; &quot;179&quot; , &quot;minor&quot; =&gt; &quot;24&quot; , &quot;subsystem&quot; =&gt; &quot;block&quot; } , &quot;subsystem&quot; =&gt; &quot;block&quot; } The non-binary values are actually the child devices of the device accessed. If you only need the actual device properties you need to filter out non-binary elements. iex&gt; get_in ( sr , [ :state , &quot;devices&quot; , &quot;platform&quot; , &quot;ocp&quot; , &quot;481d8000.mmc&quot; , &quot;mmc_host&quot; , &quot;mmc1&quot; , &quot;mmc1:0001&quot; , &quot;block&quot; , &quot;mmcblk1&quot; ] ) |&gt; Enum . filter ( fn { key , value } -&gt; is_binary ( value ) end ) |&gt; Map . new ( ) %{ &quot;devname&quot; =&gt; &quot;mmcblk1&quot; , &quot;devtype&quot; =&gt; &quot;disk&quot; , &quot;major&quot; =&gt; &quot;179&quot; , &quot;minor&quot; =&gt; &quot;8&quot; , &quot;subsystem&quot; =&gt; &quot;block&quot; }","ref":"readme.html#uevent-udev-events","title":"nerves_runtime - uevent/udev events","type":"extras"},{"doc":"Finding the serial number of a device is both hardware specific and influenced by you and your organization's choices for assigning them (or not). Programs should call Nerves.Runtime.serial_number/0 to get the serial number. Nerves systems all come with some default way of getting a serial number for a device. This strategy will likely work for a while, but may not meet your needs when it comes to production. Nerves uses boardid to read serial numbers and it can be customized via its /etc/boardid.config file. See boardid for the mechanisms available. If none of boardid 's mechanisms work for you, please consider filing an issue or making a PR, since our history has been that organizations tend to use similar mechanisms and it's likely someone else will use it too. As a word of caution, many Nerves users write serial numbers in the U-Boot environment block under the key nerves_serial_number . This is supported and documentation exists for it in many places. While it's very convenient, it has drawbacks - like it's easily modified. It's definitely not the only mechanism. The boardid.config file supports trying multiple ways of getting a serial number to handle hardware changing over the course of development. See embedded-elixir for how to assign serial numbers to devices using the U-Boot environment block way.","ref":"readme.html#serial-numbers","title":"nerves_runtime - Serial numbers","type":"extras"},{"doc":"Applications that depend on nerves_runtime for accessing provisioning information from the Nerves.Runtime.KV can mock the contents with the included Nerves.Runtime.KV.Mock module through the Application config: config :nerves_runtime , Nerves.Runtime.KV.Mock , %{ &quot;key&quot; =&gt; &quot;value&quot; } You can also create your own module based on the Nerves.Runtime.KV behavior and set it to be used in the Application config. In most situations, the provided Nerves.Runtime.KV.Mock should be sufficient, though this would be helpful in cases where you might need to generate the initial state at runtime instead: defmodule MyApp.KV.Mock do @behaviour Nerves.Runtime.KV @impl Nerves.Runtime.KV def init ( _opts ) do # initial state %{ &quot;howdy&quot; =&gt; &quot;partner&quot; , &quot;dynamic&quot; =&gt; some_runtime_calc_function ( ) } end @impl Nerves.Runtime.KV def put ( _map ) , do : :ok end # Then in config.exs config :nerves_runtime , :modules , [ { Nerves.Runtime.KV , MyApp.KV.Mock } ]","ref":"readme.html#using-nerves_runtime-in-tests","title":"nerves_runtime - Using nerves_runtime in tests","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"New features Added support for implementing auto-revert logic using U-Boot's bootcount/upgrade_available feature. This can simplify U-Boot scripts. See the README.md for details. Bug fixes Specify &quot;-f&quot; to force f2fs filesystem formats like those of other filesystems. Thank to Eric Rauer for catching this oversight.","ref":"changelog.html#v0-11-6","title":"Changelog - v0.11.6","type":"extras"},{"doc":"Updates If /etc/sysctl.conf is present, run sysctl to load and set the kernel configuration parameters in it. Improve C compilation messages and error help","ref":"changelog.html#v0-11-5","title":"Changelog - v0.11.5","type":"extras"},{"doc":"Updates Added Nerves.Runtime.firmware_valid?/0 to easily check whether the firmware has been marked valid for systems that auto-rollback.","ref":"changelog.html#v0-11-4","title":"Changelog - v0.11.4","type":"extras"},{"doc":"Updates Support uboot_env v0.3.0. This version of uboot_env has backwards incompatible changes, but they don't affect nerves_runtime , so the mix.exs deps spec allows it now. Tightened up the specs on Nerves.Runtime.KV functions. Support for OTP 20 was removed. uboot_env v0.3.0 requires OTP 21 and later. If you still are using OTP 20, lock the version of uboot_env to ~&gt; 0.2.0 in your mix.exs .","ref":"changelog.html#v0-11-3","title":"Changelog - v0.11.3","type":"extras"},{"doc":"New features Added Nerves.Runtime.validate_firmware/0 for validating firmware on systems that auto-rollback. This only abstracts the setting of the nerves_fw_validated key. It doesn't add any new functionality. However, it will enable auto-rollback to be added to Nerves systems in a consistent manner in the future and allow for platform-specific variations without impacting application code.","ref":"changelog.html#v0-11-2","title":"Changelog - v0.11.2","type":"extras"},{"doc":"Bug fixes Reap zombie process that was created by the uevent port helper. Support uboot_env v0.2.0 to reduce memory garbage that's created when reading and writing U-Boot environment blocks","ref":"changelog.html#v0-11-1","title":"Changelog - v0.11.1","type":"extras"},{"doc":"New features Add Nerves.Runtime.serial_number/0 . It will call out to the underlying system to return the device's serial number however it's stored. Add a fallback to haveged for systems that don't have hardware random number generators or otherwise can't use rngd .","ref":"changelog.html#v0-11-0","title":"Changelog - v0.11.0","type":"extras"},{"doc":"Bug fixes Fix potential process accumulation from the kmsg_tailer process ignoring stdin being closed on it. Tightened deps to avoid combinations that would be difficult to support","ref":"changelog.html#v0-10-3","title":"Changelog - v0.10.3","type":"extras"},{"doc":"Bug fixes Fix off-by-one error when processing uevent messages with device paths longer than 16 segments. This also bumps the max number of segments to 32. Fix logger message about rngd failing when it was successful Log errors when required commands aren't available rather than raising. It turned out that raising was disabling logging and that was making it hard to figure out the root cause. Enhancements Switch from parsing /proc/kmsg to /dev/kmsg for kernel messages. The device interface supplies a little more information and is unaffected by other programs reading from it. This change refactored syslog/kmsg parsing to improve test coverage. This is considered to be an internal API. If you were using it, you will need to update your code.","ref":"changelog.html#v0-10-2","title":"Changelog - v0.10.2","type":"extras"},{"doc":"Bug fixes Fix exception on init when mounting the application data partition. This addresses an issue where :nerves_runtime would exit due to an unmatched call to System.cmd/3 .","ref":"changelog.html#v0-10-1","title":"Changelog - v0.10.1","type":"extras"},{"doc":"New feature Added Nerves.Runtime.KV.put and Nerves.Runtime.KV.put_active to support setting environment. This removes the need to run fw_setenv and also updates the cached key/value pairs. Thanks to Troels Brødsgaard for implementing.","ref":"changelog.html#v0-10-0","title":"Changelog - v0.10.0","type":"extras"},{"doc":"Bug fixes Fix C compiler error (PATH_MAX undeclared) on x86_64/muslc systems","ref":"changelog.html#v0-9-5","title":"Changelog - v0.9.5","type":"extras"},{"doc":"Enhancements Reduced number of syscalls needed for transferring device detection events (uevents) to Elixir by batching them Improved start up performance by moving initial device enumeration to C Handle uevent overloads by dropping messages rather than crashing. Uevent bursts are handled better by the new batching, but can be more severe due to faster enumeration. Both dropping and crashing have drawbacks, but dropping made it possible to recover on a 32-processor machine with many peripherals.","ref":"changelog.html#v0-9-4","title":"Changelog - v0.9.4","type":"extras"},{"doc":"Enhancements Move C build products to under _build","ref":"changelog.html#v0-9-3","title":"Changelog - v0.9.3","type":"extras"},{"doc":"Enhancements Support disabling SystemRegistry integration. This is not a recommended setting and should only be used on slow devices that don't need device insertion/removal notifications.","ref":"changelog.html#v0-9-2","title":"Changelog - v0.9.2","type":"extras"},{"doc":"Enhancements Filter out synth_uuid from uevent reports since it's not supported by the current uevent handling code. Further reduce garbage produced by processing uevent reports","ref":"changelog.html#v0-9-1","title":"Changelog - v0.9.1","type":"extras"},{"doc":"The Nerves Runtime Helpers have been extracted and are now part of Toolshed . The helpers included things like cmd/1 and reboot/0 that you could run at the IEx prompt. Toolshed is not included as a dependency. If you would like it, please add toolshed to your application dependencies. You'll find that Toolshed contains more helpers. It is also easier for us to maintain since changes to the helpers no longer affect all Nerves projects. Enhancements Further optimize enumeration of devices at boot. This fixes an issue where uniprocessor boards (like the RPi Zero and BBB) would appear to stall momentarily on boot. The U-Boot environment processing code has been factored out of nerves_runtime so that it can be used independently from Nerves. It can be found at uboot_env .","ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras"},{"doc":"Enhancements Optimized enumeration of devices at boot. You will likely notice devices becoming available more quickly. This may uncover race conditions in application initialization code. The syslog monitoring code has been rewritten in pure Elixir. This component captures log messages sent by C programs using the syslog system call so that they can be handled by Elixir Logger backends. The kmsg log monitor still requires C, but the C code is simpler now that it doesn't process syslog messages as well. The Linux uevent processing code was simplified and the C to Elixir communications refactored to minimize processing of events. Bug fixes Fixed a race condition with the Linux kernel and processing /sys/devices that could cause an exception during device enumeration. Syslog messages w/o terminating newlines are logged now.","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"Enhancements Documentation updates to nerves_serial_number , nerves_validated , and nerves_autovalidate . Added helper function Nerves.Runtime.KV.UBootEnv.put/2 for writing to the UBoot env. This is useful for setting provisioning information at runtime. Added the ability to mock the contents of Nerves.Runtime.KV for use in test and dev. The contents can be set in your application config. config :nerves_runtime, :modules, [ { Nerves.Runtime.KV.Mock , %{ &quot;key&quot; =&gt; &quot;value&quot; } } ] Bug fixes Kernel uevent change messages no longer cause modifications to system_registry.","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Update dependencies to only include dialyxir for [:dev, :test] , preventing it from being distributed in the with the hex package. This addresses an issue where dialyxir and its dependencies would be included in the applications list when producing the OTP release and cause :wx to raise because the target version of erts was compiled without it.","ref":"changelog.html#v0-6-5","title":"Changelog - v0.6.5","type":"extras"},{"doc":"Bug fixes Fix U-Boot environment load issue and add unit tests to cover environment block generation using either U-Boot tools or fwup Load rngd if available. If it's available, this greatly shortens the time for the Linux kernel's random number entropy pool to initialize. This improves boot time for applications that need random numbers right away.","ref":"changelog.html#v0-6-4","title":"Changelog - v0.6.4","type":"extras"},{"doc":"Bug fixes Fix issue with parsing fw_env.config files with space separated values.","ref":"changelog.html#v0-6-3","title":"Changelog - v0.6.3","type":"extras"},{"doc":"Enhancements Updates to docs and typespecs. Bug fixes Read the U-Boot environment directly using :file if possible. (OTP-21) This fixes an issue with fw_printenv where multi-line values cause the output to be unparseable.","ref":"changelog.html#v0-6-2","title":"Changelog - v0.6.2","type":"extras"},{"doc":"Bug fixes Log the output of system commands to that they're easier to review Support mounting f2fs (requires support in the Nerves system to work)","ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras"},{"doc":"New features Forward operating system messages from /dev/log and /proc/kmsg to Elixir's Logger . If the log volume is too much to the console, consider replacing the console logger with ring_logger or another logger backend. Bug Fixes cmd/1 helper improvements to interactively print output from long running commands. Nerves.Runtime.revert would always reboot even if told not to. Cleanup throughout to improve docs, formatting, and newer Elixir stylistic conventions Remove scary suid printout when crosscompiling since nothing setuid related was going on.","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"Enhancements Added Nerves.Runtime.revert to revert the device to the inactive firmware. To use this, the Nerves system needs to include revert instructions. This is currently being implemented. Bug Fixes Setuid the uevent port binary for debugging on the host.","ref":"changelog.html#v0-5-2","title":"Changelog - v0.5.2","type":"extras"},{"doc":"Bug Fixes Split device attributes into only two parts","ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","type":"extras"},{"doc":"The Nerves runtime shell (the bash shell-like shell from CTRL+G) has been moved to a separate project so that it can evolve independently from nerves_runtime . As such, it's no longer available, but see the nerves_runtime_shell project to include it again. Enhancements Force application partition UUID. The UUID has previously been random. The main reason for change is to avoid a delay when waiting for the urandom pool to initialize. Having a known UUID for the application partition may come in handy in the future, though.","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"Enhancements Added installation helper for Nerves.Runtime.Helpers Privatized methods in KV so that they don't show up in the tab complete and help screens.","ref":"changelog.html#v0-4-4","title":"Changelog - v0.4.4","type":"extras"},{"doc":"Enhancements The Nerves.Runtime.Helpers module provides a number of functions that are useful when working at the IEx prompt on a target.","ref":"changelog.html#v0-4-3","title":"Changelog - v0.4.3","type":"extras"},{"doc":"Enhancements Makefile only builds for Linux hosts or cross compile environments. Allows package to compile on other platforms.","ref":"changelog.html#v0-4-2","title":"Changelog - v0.4.2","type":"extras"},{"doc":"Bug Fixes Fixed issue with the order of args being passed to mkfs","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"Enhancements Loosen dependency requirements on SystemRegistry","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"Bug Fixes Increased erl_cmd buffer size to 2048 to prevent segfaults with uevents for devices with many attributes.","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Enhancements Removed GenStage in favor of SystemRegistry Added KV firmware variable key value store Added Init worker for initializing the application partition","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Enhancements Moved hardware abstraction layer to separate project for further development Start the shell using the name sh instead of 'Elixir.Nerves.Runtime.Shell'","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Bug fixes Cleaned up IO Rename host to sh","ref":"changelog.html#v0-1-2","title":"Changelog - v0.1.2","type":"extras"}]